Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCaptureAtRest.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCaptureAtRest.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCaptureAtRest.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4QCaptureAtRest.cc,v 1.18 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCaptureAtRest.cc,v 1.20 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCaptureAtRest class -----------------
@@ -35,4 +35,12 @@
 // ******* DO NOT MAKE ANY CHANGE! With time it'll move back to photolepton...(M.K.) ******
 // ****************************************************************************************
+// Short Description: This is a universal process for nuclear capture
+// (including annihilation) of all negative particles (negative hadrons,
+// negative leptons: mu- & tau-). It can be used for the cold neutron
+// capture, but somebody should decide what is the probability (defined
+// by the capture cross-section and atomic material properties) to switch
+// the cold neutron to the at-rest neutron. - M.K.2009.
+// ----------------------------------------------------------------------
+
 
 //#define debug
@@ -105,5 +113,8 @@
 
 G4QCaptureAtRest::~G4QCaptureAtRest()
-{}
+{
+  // deregister in the store
+  G4HadronicProcessStore::Instance()->DeRegisterExtraProcess(this);
+}
 
 G4LorentzVector G4QCaptureAtRest::GetEnegryMomentumConservation()
@@ -170,5 +181,5 @@
   static G4bool CWinit = true;                       // CHIPS Warld needs to be initted
   if(CWinit)
-		{
+  {
     CWinit=false;
     G4QCHIPSWorld::Get()->GetParticles(nPartCWorld); // Create CHIPS World (234 part.max)
@@ -219,5 +230,5 @@
   for(i=0; i<nE; ++i)
   {
-   	G4double frac=material->GetFractionVector()[i];
+    G4double frac=material->GetFractionVector()[i];
     if(projPDG==13||projPDG==15)
     {
@@ -258,5 +269,5 @@
 #endif
     if(!Isotopes->IsDefined(Z,indEl))      // This index is not defined for this Z: define
-				{
+    {
       std::vector<std::pair<G4int,G4double>*>* newAbund =
                                                new std::vector<std::pair<G4int,G4double>*>;
@@ -266,12 +277,12 @@
         N=pElement->GetIsotope(j)->GetN()-Z;
         if(pElement->GetIsotope(j)->GetZ()!=Z) G4cerr<<"*G4QCaptureAtRest::AtRestDoIt: Z="
-																																							 <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
+                                        <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
         G4double abund=abuVector[j];
-								std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
+        std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
 #ifdef debug
         G4cout<<"G4QCaptureAtRest::AtRestDoIt:pair#="<<j<<", N="<<N<<",ab="<<abund<<G4endl;
 #endif
         newAbund->push_back(pr);
-						}
+      }
 #ifdef debug
       G4cout<<"G4QCaptureAtRest::AtRestDoIt: pairVectorLength="<<newAbund->size()<<G4endl;
@@ -292,5 +303,5 @@
   if(dsr<dd)dsr=dd;
   if(manualFlag) G4QNucleus::SetParameters(freeNuc,freeDib,clustProb,mediRatio); // ManualP
-		else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
+  else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
   else if(projPDG==-211)  G4QNucleus::SetParameters(.67-dsr,.32-dsr,5.,9.);//Pi- ClustPars
 #ifdef debug
@@ -330,6 +341,6 @@
 #endif
   localtime += Time;
-	 std::vector<G4double>* cascE = new std::vector<G4double>;
-	 std::vector<G4Track*>* cascT = new std::vector<G4Track*>;
+  std::vector<G4double>* cascE = new std::vector<G4double>;
+  std::vector<G4Track*>* cascT = new std::vector<G4Track*>;
   G4bool neutronElastic = false;             // Flag of elastic neutro-nucleeus Scattering
   G4bool chargExElastic = false;             // Flag of charge exchange Quasi-Elastic Scat.
@@ -361,5 +372,5 @@
       if(eNeut<.0001) chargExElastic=true;    // neutron is too soft -> charge Exchange
       else
-						{
+      {
         G4double probP=std::sqrt(eProt*(dmProt+eProt));
         G4double probN=std::sqrt(eNeut*(dmNeut+eNeut));
@@ -368,5 +379,5 @@
       }
     }
-				else if(mAR<=mAN||(mAR<=mAP+mProt&&mAR<=mAA+mAlph)) // Impossible to radiate n or Alpha
+    else if(mAR<=mAN||(mAR<=mAP+mProt&&mAR<=mAA+mAlph)) // Impossible to radiate n or Alpha
     {
 #ifdef debug
@@ -383,5 +394,5 @@
   if(projPDG==15) nuPDG=16;
 #ifdef debug
-		G4int CV=0;
+  G4int CV=0;
   G4cout<<"G4QCaptureAtRest::AtRestDoIt:DecayIf is reached CV="<<CV<<G4endl;
 #endif
@@ -431,5 +442,5 @@
 #endif
   }
-		else if(projPDG==-211 && targPDG==90001000)// Use Panofsky Ratio for (p+pi-) system decay
+  else if(projPDG==-211 && targPDG==90001000)// Use Panofsky Ratio for (p+pi-) system decay
   {                                          // (p+pi-=>n+pi0)/p+pi-=>n+gamma) = 3/2
 #ifdef debug
@@ -440,5 +451,5 @@
     G4double pigamM=mPi0;
     if(G4UniformRand()>0.6)
-	   {
+    {
       pigamPDG=22;
       pigamM=0.;
@@ -463,5 +474,5 @@
     G4LorentzVector totLV(0.,0.,0.,mp+mt);   // 4-momentum of the (A+pi-) compound system
     if(Z==1 && N==1)                         // Quasi-Free process on Deuteron
-	   {
+    {
       G4LorentzVector f4Mom(0.,0.,0.,mNeut); // First neutron 
       G4LorentzVector s4Mom(0.,0.,0.,mNeut); // Second neutron
@@ -505,6 +516,6 @@
       G4int nsec=cascE->size();
       G4DynamicParticle* theSec = 0; // Prototype to fill particle in the G4ParticleChange
-	     for(G4int is=0; is<nsec; is++)
-	     {
+      for(G4int is=0; is<nsec; is++)
+      {
         G4double ener=cascE->operator[](is);
         if(ener>0) theSec = new G4DynamicParticle(G4Electron::Electron(),RndmDir(),ener);
@@ -517,5 +528,5 @@
       }
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: e+nu+nu decay 4M="<<totLV<<totLV.m()<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: e+nu+nu decay 4M="<<totLV<<totLV.m()<<G4endl;
 #endif
       G4double mt=G4QPDGCode(targPDG).GetMass();// Mass of the target Nucleus
@@ -524,6 +535,6 @@
       G4double mmt=totLV.m();                   // Total energy of the compound system
       if(ee>=mbm*(mmt-mbm/2)/mmt)
-				  {
-  	     G4cout<<"-W-G4QCaptureAtRest::AtRestDoIt: Unrealistic E="<<ee<<", m="<<mMu<<G4endl;
+      {
+        G4cout<<"-W-G4QCaptureAtRest::AtRestDoIt: Unrealistic E="<<ee<<", m="<<mMu<<G4endl;
         G4LorentzVector f4Mom(0.,0.,0.,mEl);    // Electron
         G4LorentzVector s4Mom(0.,0.,0.,mt);     // Quark-A
@@ -551,5 +562,5 @@
 #ifdef debug
         G4double fe=f4Mom.e();
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt: Ei="<<ee<<",Ef="<<fe<<",de="<<fe-ee<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt: Ei="<<ee<<",Ef="<<fe<<",de="<<fe-ee<<G4endl;
 #endif
         G4QHadron* electron = new G4QHadron(11,f4Mom); // Create Electron
@@ -564,33 +575,33 @@
         }
 #ifdef debug
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt: (A+2nu) Decay is successful - 2"<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt: (A+2nu) Decay is successful - 2"<<G4endl;
 #endif
         G4QHadron* resnuc = new G4QHadron(targPDG,r4Mom); // Creation Hadron for ResidNucl
 #ifdef debug
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt: ResNuc 4M="<<mt<<r4Mom<<r4Mom.m()<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt: ResNuc 4M="<<mt<<r4Mom<<r4Mom.m()<<G4endl;
 #endif
         output->push_back(resnuc);               // Fill the Residual Nucleus to the output
 #ifdef debug
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt: ResNuc is filled nu="<<n4Mom<<nuPDG<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt: ResNuc is filled nu="<<n4Mom<<nuPDG<<G4endl;
 #endif
         G4QHadron* numu = new G4QHadron(nuPDG,n4Mom); // Create Hadron for LeptonicNeutrino
         output->push_back(numu);                      // Fill Muonic Neutrino to the output
 #ifdef debug
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt:Nu is filled,anu="<<a4Mom<<a4Mom.m()<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt:Nu is filled,anu="<<a4Mom<<a4Mom.m()<<G4endl;
 #endif
         G4QHadron* anue = new G4QHadron(-12,a4Mom); // Create Hadron for the AntiE Neutrino
         output->push_back(anue);                    // Fill the AntiENeutrino to the output
 #ifdef debug
-	       G4cout<<"G4QCaptureAtRest::AtRestDoIt: anu is filled == Success of Mu-cap"<<G4endl;
+        G4cout<<"G4QCaptureAtRest::AtRestDoIt: anu is filled == Success of Mu-cap"<<G4endl;
 #endif
       }
     }
     else                                            // @@Should be developed for tau-lepton
-				{
-						G4int deL=11;                                 // Prototype of decay lepton
+    {
+      G4int deL=11;                                 // Prototype of decay lepton
       G4int deN=-12;                                // Prototype of decay neutrino
       G4double mdl=mEl;                             // Prototype of the decay mass
       if(G4UniformRand()>.55)                       // Use mu decay instead of e-decay
-						{
+      {
         deL=13;
         deN=-14;
@@ -606,22 +617,22 @@
       }
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: Tau Decay is successful"<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: Tau Decay is successful"<<G4endl;
 #endif
       G4QHadron* lept = new G4QHadron(deL,e4Mom);   // Creation Hadron for the Electron
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: lepton 4M="<<e4Mom<<e4Mom.m()<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: lepton 4M="<<e4Mom<<e4Mom.m()<<G4endl;
 #endif
       output->push_back(lept);                      // Fill the Electron in the output
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: lepton is filled nu="<<n4Mom<<nuPDG<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: lepton is filled nu="<<n4Mom<<nuPDG<<G4endl;
 #endif
       G4QHadron* nuta = new G4QHadron(nuPDG,n4Mom); // Create Hadron for LeptonicNeutrino
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: nu 4M="<<n4Mom<<n4Mom.m()<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: nu 4M="<<n4Mom<<n4Mom.m()<<G4endl;
 #endif
       output->push_back(nuta);                      // Fill Muonic Neutrino to the output
       G4QHadron* anul = new G4QHadron(deN,a4Mom);   // Create Hadron for the AntiE Neutrino
 #ifdef debug
-  	   G4cout<<"G4QCaptureAtRest::AtRestDoIt: antiNu 4M="<<a4Mom<<a4Mom.m()<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: antiNu 4M="<<a4Mom<<a4Mom.m()<<G4endl;
 #endif
       output->push_back(anul);                      // Fill the AntiENeutrino to the output
@@ -632,5 +643,5 @@
     G4LorentzVector totLV(0.,0.,0.,mp+mProt-EnergyDeposition);// 4-mom of theCompoundSystem
 #ifdef debug
-	   G4cout<<"G4QCaptureAtRest::AtRestDoIt:CapOnProton decay 4M="<<totLV<<totLV.m()<<G4endl;
+    G4cout<<"G4QCaptureAtRest::AtRestDoIt:CapOnProton decay 4M="<<totLV<<totLV.m()<<G4endl;
 #endif
     G4LorentzVector g4Mom(0.,0.,0.,0.);      // mass of the muon neutrino
@@ -650,5 +661,5 @@
     G4LorentzVector totLV(0.,0.,0.,mp+mDeut-EnergyDeposition);// 4-mom of theCompoundSystem
 #ifdef debug
-	   G4cout<<"G4QCaptureAtRest::AtRestDoIt: CapOnDeutr decay 4M="<<totLV<<totLV.m()<<G4endl;
+    G4cout<<"G4QCaptureAtRest::AtRestDoIt: CapOnDeutr decay 4M="<<totLV<<totLV.m()<<G4endl;
 #endif
     G4LorentzVector g4Mom(0.,0.,0.,0.);      // mass of the muon neutrino
@@ -673,5 +684,5 @@
     G4LorentzVector totLV(0.,0.,0.,mp+mt-EnergyDeposition);// 4-mom of the(A+mu-) compound
 #ifdef debug
-	   G4cout<<"G4QCaptureAtRest::AtRestDoIt: Quasi-Free decay 4M="<<totLV<<totLV.m()<<G4endl;
+    G4cout<<"G4QCaptureAtRest::AtRestDoIt: Quasi-Free decay 4M="<<totLV<<totLV.m()<<G4endl;
 #endif
     G4int rPDG=targPDG-1000;                  // Subtract one proton from the nucleus
@@ -693,10 +704,10 @@
   }
   else                                        // *** THIS works for all particles ! ***
-		//else if(1>2)// !! Immediately change back - Very temporary to avoid nuclear capture !!
+  //else if(1>2)// !! Immediately change back - Very temporary to avoid nuclear capture !!
   {
     G4QHadron* neutr = 0; // Create Neutrino
     if(projPDG==13||projPDG==15) mp-=EnergyDeposition;//TheEnergyDeposit is only for LepCap
 #ifdef debug
-	   G4cout<<"G4QCaptureAtRest::AtRestDoIt: CHIPS M="<<mp<<",dE="<<EnergyDeposition<<G4endl;
+    G4cout<<"G4QCaptureAtRest::AtRestDoIt: CHIPS M="<<mp<<",dE="<<EnergyDeposition<<G4endl;
 #endif
     G4LorentzVector projLV(0.,0.,0.,mp);
@@ -706,6 +717,6 @@
       G4int nsec=cascE->size();
       G4DynamicParticle* theSec = 0; // Prototype to fill particle in the G4ParticleChange
-	     for(G4int is=0; is<nsec; is++)
-	     {
+      for(G4int is=0; is<nsec; is++)
+      {
         G4double ener=cascE->operator[](is);
         if(ener>0) theSec = new G4DynamicParticle(G4Electron::Electron(),RndmDir(),ener);
@@ -737,5 +748,5 @@
         G4double qp=std::pow((std::pow(1.+ga*std::pow(hmm,b1),G4UniformRand())-1.)/ga,rb);
         G4double mqq=0.;
-						  if(qp<hmm) mqq=std::sqrt(mmu2-dmm*qp);
+        if(qp<hmm) mqq=std::sqrt(mmu2-dmm*qp);
         G4LorentzVector f4Mom(0.,0.,0.,0.);      // Muon neutrino 
         G4LorentzVector s4Mom(0.,0.,0.,mqq);     // Quark-Antiquark
@@ -767,18 +778,18 @@
 #endif
     try                                                           //                 |
-	   {                                                             //                 |
-	     delete output;                                              //                 |
+    {                                                             //                 |
+      delete output;                                              //                 |
       output = pan->Fragment();// DESTROYED in the end of the LOOP work space        |
     }                                                             //                 |
     catch (G4QException& error)//                                                    |
-	   {                                                             //                 |
-	     //#ifdef pdebug
+    {                                                             //                 |
+      //#ifdef pdebug
       G4cerr<<"***G4QCaptureAtRest::AtRestDoIt: Exception is catched"<<G4endl; //    |
-	     //#endif
+      //#endif
       G4Exception("G4QCaptureAtRest::AtRestDoIt:","27",FatalException,"Gen.CHIPS Except.");
     }                                                             //                 |
     delete pan;                              // Delete the Nuclear Environment <--<--+
 #ifdef debug
-	   G4cout<<"G4QCaptureAtRest::AtRestDoIt: CHIPS fragmentation is done, CV="<<CV<<G4endl;
+    G4cout<<"G4QCaptureAtRest::AtRestDoIt: CHIPS fragmentation is done, CV="<<CV<<G4endl;
 #endif
     // ----- Ericson mu to pi conversion ----- ????? -----
@@ -790,5 +801,5 @@
   G4int nsec=cascE->size();
   aParticleChange.SetNumberOfSecondaries(tNH+nsec); 
-	 for(G4int is=0; is<nsec; is++) aParticleChange.AddSecondary((*cascT)[is]);
+  for(G4int is=0; is<nsec; is++) aParticleChange.AddSecondary((*cascT)[is]);
   cascE->clear();
   delete cascE;
@@ -809,5 +820,5 @@
     {
 #ifdef debug
-	     G4cout<<"G4QCaptureAtRest::AtRestDoIt: Intermediate particle is found i="<<i<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt: Intermediate particle is found i="<<i<<G4endl;
 #endif
       delete hadr;
@@ -826,5 +837,5 @@
     {
       if(G4UniformRand()>.5) theDefinition = G4KaonZeroLong::KaonZeroLong();   // K_L
-						else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
+      else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
     }
     else if(PDGCode==91000999) theDefinition = G4SigmaPlus::SigmaPlus();
@@ -833,10 +844,10 @@
     else if(PDGCode==91999999) theDefinition = G4XiZero::XiZero();
     else if(PDGCode==92998999) theDefinition = G4OmegaMinus::OmegaMinus();
-	   else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
+    else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
     {
       G4int aZ = hadr->GetCharge();
       G4int aA = hadr->GetBaryonNumber();
 #ifdef pdebug
-						G4cout<<"G4QCaptureAtRest::AtRestDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
 #endif
       //if      (PDGCode==90001001) theDefinition = G4Deuteron::Deuteron();
@@ -850,9 +861,9 @@
     {
 #ifdef pdebug
-						G4cout<<"G4QCaptureAtRest::AtRestDoIt:Define particle with PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt:Define particle with PDG="<<PDGCode<<G4endl;
 #endif
       theDefinition = G4QPDGToG4Particle::Get()->GetParticleDefinition(PDGCode);
 #ifdef pdebug
-						G4cout<<"G4QCaptureAtRest::AtRestDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QCaptureAtRest::AtRestDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
 #endif
     }
@@ -925,5 +936,5 @@
   static const G4double rate[nAZ]={.00000045, .00000047, .00000215, .000000356, .00000468,
                                    .00000226, .00000610, .00002750, .000023500, .00003790,
-																																			.00003500, .00006600, .00006200, .000102500, .00009500,
+                                   .00003500, .00006600, .00006200, .000102500, .00009500,
                                    .00008800, .00022900};
 #ifdef debug
@@ -944,6 +955,6 @@
   else G4cout<<"--Warning--G4QCaptureAtRest::RandomizeMuDecayOrCapture: NEG Z="<<Z<<G4endl;
   mZ=Z; mN=N; mH=Huff; mR=pC;    // Remember the last calculated parameters
-  //G4double DLifeT=-std::log(G4UniformRand())/pD; // Time of the muon decay inside the atom
-  //G4double CLifeT=-std::log(G4UniformRand())/pC; // Time of the muon capture by nucleus
+  //G4double DLifeT=-std::log(G4UniformRand())/pD;// Time of the muon decay inside the atom
+  //G4double CLifeT=-std::log(G4UniformRand())/pC;// Time of the muon capture by nucleus
   //if(DLifeT<CLifeT)
   //{
@@ -958,15 +969,15 @@
   //  Time=CLifeT;
 #ifdef debug
-  //  G4cout<<"G4QCaptureAtRest::RandomizeMuDecayOrCapture: CaptureLifeTime="<<Time<<G4endl;
-#endif
-		//  return true;
+  //  G4cout<<"G4QCaptureAtRest::RandomizeMuDecayOrCapture:CaptureLifeTime="<<Time<<G4endl;
+#endif
+  //  return true;
   //}
   if((pD+pC)*G4UniformRand()>pD) // CAPTURE @@ Cash pD+pC
-		{
+  {
      Time=-std::log(G4UniformRand())/pC;
      return true;
   }
   else
-		{
+  {
      Time=-std::log(G4UniformRand())/pD;
      return false;
@@ -1035,9 +1046,9 @@
     if((nAuger < Z) && ((pGamma + 10000.0) * G4UniformRand() < 10000.0) ) // 10000 (? M.K.)
     {
-   	  nAuger++;                       // Radiate one more Auger electron
+      nAuger++;                       // Radiate one more Auger electron
       DeltaE = EnergyLevel[nLevel-1] - EnergyLevel[nLevel];
       nLevel--;
 #ifdef debug
-	  G4cout<<"G4QCaptureAtR::MuCaptureEMCascade: Auger_e E="<<DeltaE<<G4endl;
+   G4cout<<"G4QCaptureAtR::MuCaptureEMCascade: Auger_e E="<<DeltaE<<G4endl;
 #endif
       dV->push_back(DeltaE);
@@ -1052,5 +1063,5 @@
       nLevel = iLevel;
 #ifdef debug
-	     G4cout<<"G4QCaptureAtR::MuCaptureEMCascade: photon E="<<DeltaE<<G4endl;
+      G4cout<<"G4QCaptureAtR::MuCaptureEMCascade: photon E="<<DeltaE<<G4endl;
 #endif
       dV->push_back(-DeltaE);
@@ -1072,5 +1083,5 @@
   G4double Z227=Z27*Z27;
   G4double Z427=Z227*Z227;
-  G4double Zeff=(Z-0.13782)*(1.2162-(0.09118-Z427)*std::sqrt((G4double)Z)); // EffNuclear Charge
+  G4double Zeff=(Z-0.13782)*(1.2162-(0.09118-Z427)*std::sqrt((G4double)Z));// EffNuclCharge
   G4double Ze2=Zeff*Zeff;      // Squared effective charge of the Nucleus
   G4double pD=3436.*(1.-Ze2*.00014658);     //@@ 1./MeanLifeTime of Tau in atoms (in ns^-1)
@@ -1225,5 +1236,5 @@
           49.5635,49.6993,49.8367,49.9760,50.1175,50.2617,50.4091,50.5605,50.7166,50.8785,
           51.0475,51.2256,51.4151,51.6195,51.8439,52.0962,52.3897,52.7496,53.2325,54.0205};
-		//Na23(Z=11)
+  //Na23(Z=11)
   static G4double P5[nE]={
           0.00000,7.00695,8.86633,10.1943,11.2667,12.1832,12.9928,13.7237,14.3938,15.0151,
@@ -1384,10 +1395,10 @@
   static const G4int mZ=mZ1-1;    // MaxPossibleZ
   static G4double* P[mZ1]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
-																											0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
-																											0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
+                           0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
+                           0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
   //---------------------------------------------------------------------------------------
   if(z<1 || z>mZ)
-		{
-				G4cout<<"-W-G4QCapAtRest::RandomizeDecayElectron: <=0 or big(>"<<mZ<<") Z="<<z<<G4endl;
+  {
+    G4cout<<"-W-G4QCapAtRest::RandomizeDecayElectron: <=0 or big(>"<<mZ<<") Z="<<z<<G4endl;
     return 0.;
   }
@@ -1395,12 +1406,12 @@
   G4double* nP = 0;
   if(!P[z])          // The table for this element must be created
-		{
+  {
     for(G4int i=0; i<nZ; i++)
-				{
+    {
       G4double fZ=tZ[i];
       if(Z<=fZ)      // The extrapolation bin is found
-						{
-#ifdef debug
-		      G4cout<<"G4QCapAtRest::RandomizeDecayElectron: Z="<<Z<<", fZ="<<fZ<<G4endl;
+      {
+#ifdef debug
+        G4cout<<"G4QCapAtRest::RandomizeDecayElectron: Z="<<Z<<", fZ="<<fZ<<G4endl;
 #endif
         nP = new G4double[nE];
@@ -1408,7 +1419,7 @@
         if(Z==fZ) for(G4int j=0; j<nE; j++) nP[j]=fP[j];
         else
-								{
-										G4int i1=i-1;  // i>2, asthe first tabilated Z are 1,2,4,... and min_i=3
-										G4double  iZ=tZ[i1];
+        {
+          G4int i1=i-1;  // i>2, asthe first tabilated Z are 1,2,4,... and min_i=3
+          G4double  iZ=tZ[i1];
           G4double* iP=PP[i1];
           G4double rZ=(Z-iZ)/(fZ-iZ);
@@ -1416,5 +1427,5 @@
         }
 #ifdef debug
-				    for(G4int k=0; k<nE; k++)G4cout<<"G4QCAR::RandDecEle:P["<<k<<"]="<<nP[k]<<G4endl;
+        for(G4int k=0; k<nE; k++)G4cout<<"G4QCAR::RandDecEle:P["<<k<<"]="<<nP[k]<<G4endl;
 #endif
         P[z]=nP;
@@ -1432,7 +1443,7 @@
   G4double nPf=0.;
   if(iR<nEl) nPf=nP[iR+1];
-		else       nPf=nP[nEl]+(nP[nEl]-nP[nEb])/2; // An artificial tail
-#ifdef debug
-		G4cout<<"G4QCapAtR::RaDEl:R="<<R<<",Ei="<<nPi<<",E="<<MeV*(nPi+(R-iR)*(nPf-nPi))<<G4endl;
+  else       nPf=nP[nEl]+(nP[nEl]-nP[nEb])/2; // An artificial tail
+#ifdef debug
+  G4cout<<"G4QCapAtR::RaDEl:R="<<R<<",Ei="<<nPi<<",E="<<MeV*(nPi+(R-iR)*(nPf-nPi))<<G4endl;
 #endif
   return MeV*(nPi+(R-iR)*(nPf-nPi));
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCoherentChargeExchange.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCoherentChargeExchange.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCoherentChargeExchange.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4QCoherentChargeExchange.cc,v 1.7 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCoherentChargeExchange.cc,v 1.8 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCoherentChargeExchange class -----------------
@@ -34,5 +34,23 @@
 // ********** This CLASS is temporary moved from the photolepton_hadron directory *********
 // ****************************************************************************************
-
+// Short description: This class resolves an ambiguity in the definition of the
+// "inelastic" cross section. As it was shown in Ph.D.Thesis (M.Kosov,ITEP,1979)
+// it is more reasonable to subdivide the total cross-section in the coherent &
+// incoherent parts, but the measuring method for the "inelastic" cross-sections
+// consideres the lack of the projectile within the narrow forward solid angle
+// with the consequent extrapolation of these partial cross-sections, corresponding
+// to the particular solid angle, to the zero solid angle. The low angle region
+// is shadowed by the elastic (coherent) scattering. BUT the coherent charge
+// exchange (e.g. conversion p->n) is included by this procedure as a constant term
+// in the extrapolation, so the "inelastic" cross-section differes from the
+// incoherent cross-section by the value of the coherent charge exchange cross
+// section. Fortunately, this cross-sectoion drops ruther fast with energy increasing.
+// All Geant4 inelastic hadronic models (including CHIPS) simulate the incoherent
+// reactions. So the incoherent (including quasielastic) cross-section must be used
+// instead of the inelastic cross-section. For that the "inelastic" cross-section
+// must be reduced by the value of the coherent charge-exchange cross-section, which
+// is estimated (it must be tuned!) in this CHIPS class. The angular distribution
+// is made (at present) identical to the corresponding coherent-elastic scattering 
+// -----------------------------------------------------------------------------------
 //#define debug
 //#define pdebug
@@ -146,10 +164,10 @@
                                          <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
           G4double abund=abuVector[j];
-								  std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
+          std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
 #ifdef debug
           G4cout<<"G4QCohChEx::GetMeanFreePath:pair#="<<j<<",N="<<N<<",ab="<<abund<<G4endl;
 #endif
           newAbund->push_back(pr);
-						  }
+        }
 #ifdef debug
         G4cout<<"G4QCohChEx::GetMeanFreePath: pairVectorLength="<<newAbund->size()<<G4endl;
@@ -178,5 +196,5 @@
       G4cout<<"G4QCCX::GMFP:true, P="<<Momentum<<",Z="<<Z<<",N="<<N<<",PDG="<<pPDG<<G4endl;
 #endif
-		    G4bool ccsf=true;
+      G4bool ccsf=true;
       if(Q==-27.) ccsf=false;
 #ifdef debug
@@ -251,5 +269,5 @@
   static G4bool CWinit = true;                       // CHIPS Warld needs to be initted
   if(CWinit)
-		{
+  {
     CWinit=false;
     G4QCHIPSWorld::Get()->GetParticles(nPartCWorld); // Create CHIPS World (234 part.max)
@@ -323,5 +341,5 @@
 #ifdef debug
   G4int prPDG=particle->GetPDGEncoding();
-		G4cout<<"G4QCohChrgExchange::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
+  G4cout<<"G4QCohChrgExchange::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
 #endif
   if(!projPDG)
@@ -340,8 +358,8 @@
   }
   G4double pM2=pM*pM;
-		// Element treatment
+  // Element treatment
   G4int EPIM=ElProbInMat.size();
 #ifdef debug
-		G4cout<<"G4QCohChEx::PostStDoIt:m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
+  G4cout<<"G4QCohChEx::PostStDoIt:m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
 #endif
   G4int i=0;
@@ -350,7 +368,7 @@
     G4double rnd = ElProbInMat[EPIM-1]*G4UniformRand();
     for(i=0; i<nE; ++i)
-		  {
-#ifdef debug
-				  G4cout<<"G4QCohChEx::PostStepDoIt:EPM["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
+    {
+#ifdef debug
+      G4cout<<"G4QCohChEx::PostStepDoIt:EPM["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
 #endif
       if (rnd<ElProbInMat[i]) break;
@@ -361,5 +379,5 @@
   Z=static_cast<G4int>(pElement->GetZ());
 #ifdef debug
-				G4cout<<"G4QCoherentChargeExchange::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
+    G4cout<<"G4QCoherentChargeExchange::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
 #endif
   if(Z<=0)
@@ -372,5 +390,5 @@
   G4int nofIsot=SPI->size();               // #of isotopes in the element i
 #ifdef debug
-		G4cout<<"G4QCohChargeExchange::PosStDoIt:nI="<<nofIsot<<",T="<<(*SPI)[nofIsot-1]<<G4endl;
+  G4cout<<"G4QCohChargeExchange::PosStDoIt:nI="<<nofIsot<<",T="<<(*SPI)[nofIsot-1]<<G4endl;
 #endif
   G4int j=0;
@@ -381,5 +399,5 @@
     {
 #ifdef debug
-				  G4cout<<"G4QCohChargEx::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<", r="<<rndI<<G4endl;
+      G4cout<<"G4QCohChargEx::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<", r="<<rndI<<G4endl;
 #endif
       if(rndI < (*SPI)[j]) break;
@@ -389,5 +407,5 @@
   G4int N =(*IsN)[j]; ;                    // Randomized number of neutrons
 #ifdef debug
-		G4cout<<"G4QCohChargeEx::PostStepDoIt: j="<<i<<", N(isotope)="<<N<<", MeV="<<MeV<<G4endl;
+  G4cout<<"G4QCohChargeEx::PostStepDoIt: j="<<i<<", N(isotope)="<<N<<", MeV="<<MeV<<G4endl;
 #endif
   if(N<0)
@@ -505,5 +523,5 @@
   aParticleChange.ProposeTrackStatus(fStopAndKill);
   // Definition of the scattered nucleon
-		G4DynamicParticle* theSec = new G4DynamicParticle; // A secondary for the recoil hadron 
+  G4DynamicParticle* theSec = new G4DynamicParticle; // A secondary for the recoil hadron 
   G4ParticleDefinition* theDefinition=G4Proton::Proton();
   if(projPDG==2212) theDefinition=G4Neutron::Neutron();
@@ -516,8 +534,8 @@
   aParticleChange.AddSecondary( aNewTrack );
   // Filling the recoil nucleus
-		theSec = new G4DynamicParticle; // A secondary for the recoil hadron 
+  theSec = new G4DynamicParticle; // A secondary for the recoil hadron 
   G4int aA = Z+N;
 #ifdef pdebug
-		G4cout<<"G4QCoherentChargeExchange::PostStepDoIt: Ion Z="<<Z<<", A="<<aA<<G4endl;
+  G4cout<<"G4QCoherentChargeExchange::PostStepDoIt: Ion Z="<<Z<<", A="<<aA<<G4endl;
 #endif
   theDefinition=G4ParticleTable::GetParticleTable()->FindIon(Z,aA,0,Z);
@@ -577,5 +595,5 @@
   {
     if(oxs) res=CSmanager->GetHMaxT();   // Calculate the max_t value
-				else res=CSmanager->GetExchangeT(Z, N, pPDG); // fanctionally randomized -t in MeV^2
+    else res=CSmanager->GetExchangeT(Z, N, pPDG); // fanctionally randomized -t in MeV^2
   }
   else G4cout<<"*Warning*G4QCohChrgExchange::CalculateXSt: NotInitiatedScattering"<<G4endl;
